      PROGRAM MAIN
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c              Post Process an Integer Coded Realization
c              *****************************************
c
c Input image(s) are post-processed with a steepest descent approach
c so that the two-point histogram for specified directions and lags are
c identified to that of a training image.
c
c
c
c INPUT/OUTPUT Variables:
c
c    datafl     file containing realizations to be post-processed
c    trainfl    file containing the training image
c    outfl      output file for post-processed realizations
c    idbg       debugging level (0-3)
c    report     after ``report'' loops the image is written to the
c               output file
c    dbgfl      output file for debugging information
c    seed       random number seed
c    maxit      maximum number of iterations over all nodes
c    tol        tolerance for the objective function (starts at 1)
c    nsim       number of simulations to post-process
c    nx,ny,nz   grid size for the input realizations AND training image
c    ndir       the number of directions to consider for the two-point
c               histogram control
c    ixl(),iyl(),izl()  the offsets for each direction
c
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      PARAMETER (MAXX = 150, MAXY = 150, MAXZ = 1, MAXLAG = 24, MAXDIR
     1    = 4, MAXRC = 10, MAXROC = MAXRC + 1, VERSION = 2.000)
c
c ACORN parameters:
c
      PARAMETER (KORDEI = 12, MAXOP1 = KORDEI + 1, MAXINT = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      REAL PROP(11)
      INTEGER VAR(150,150,1), NTRAIN(11,11,4,24), NACT(11,11,4,24), NTRY
     1   (10,11,11,4,24), NUM(4,24), SEED, REPORT, IXL(4), IYL(4), IZL(4
     2   ), NLAG(4), ICROSS(4), ICAT(11)
      CHARACTER DATAFL*40, TRAINFL*40, OUTFL*40, DBGFL*40
 
      COMMON /IACO/IXV(MAXOP1)
 
      COMMON /GENRAL/NSIM, NX, NY, NZ, NR, NP, NV, LOUT, IDBG, REPORT, 
     1   LDBG, SEED, MAXIT, TOL, VAR, NUM, NDIR, NLAG, MLAG, IXL, IYL, 
     2   IZL, ICROSS, NTRY, NTRAIN, NACT, PROP, NCAT, ICAT
 
      COMMON /CHARAC/DATAFL, TRAINFL, OUTFL, DBGFL
      CALL READPARM
c
c LOOP over all the simulations:
c
      DO ISIM = 1, NSIM
         CALL INITGRID
         CALL TPHIST (1)
         CALL SIM
         CALL TPHIST (1)
      END DO
c
c Finished:
c
      CLOSE(LOUT)
      CLOSE(LDBG)
      WRITE (*, 9998) 2.000
 9998 FORMAT(/' ANNEAL Version: ',F5.3,' Finished'/)
      STOP 
      END 
 
 
 
      SUBROUTINE INITGRID
c-----------------------------------------------------------------------
c
c                      Initialization of Grid
c                      **********************
c
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      PARAMETER (MAXX = 150, MAXY = 150, MAXZ = 1, MAXLAG = 24, MAXDIR
     1    = 4, MAXRC = 10, MAXROC = MAXRC + 1, VERSION = 2.000)
c
c ACORN parameters:
c
      PARAMETER (KORDEI = 12, MAXOP1 = KORDEI + 1, MAXINT = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      REAL PROP(11)
      INTEGER VAR(150,150,1), NTRAIN(11,11,4,24), NACT(11,11,4,24), NTRY
     1   (10,11,11,4,24), NUM(4,24), SEED, REPORT, IXL(4), IYL(4), IZL(4
     2   ), NLAG(4), ICROSS(4), ICAT(11)
      CHARACTER DATAFL*40, TRAINFL*40, OUTFL*40, DBGFL*40
 
      COMMON /IACO/IXV(MAXOP1)
 
      COMMON /GENRAL/NSIM, NX, NY, NZ, NR, NP, NV, LOUT, IDBG, REPORT, 
     1   LDBG, SEED, MAXIT, TOL, VAR, NUM, NDIR, NLAG, MLAG, IXL, IYL, 
     2   IZL, ICROSS, NTRY, NTRAIN, NACT, PROP, NCAT, ICAT
 
      COMMON /CHARAC/DATAFL, TRAINFL, OUTFL, DBGFL
      DATA LINP/ 10/ 
c
c Read in a new initial image:
c
      DO IZ = 1, NZ
         DO IY = 1, NY
            DO IX = 1, NX
               READ (LINP, *) TEMPVAR
               K = INT(TEMPVAR + 0.5)
               DO I = 1, NR
                  IF (K .EQ. ICAT(I)) ICODE = I
               END DO
               VAR(IX,IY,IZ) = ICODE
            END DO
         END DO
      END DO
      RETURN 
      END 
 
 
 
      subroutine sim
c-----------------------------------------------------------------------
c
c               MAIN ROUTINE TO PERFORM THE SIMULATION
c
c
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      parameter (maxx = 150, maxy = 150, maxz = 1, maxlag = 24, maxdir
     1    = 4, maxrc = 10, maxroc = maxrc + 1, version = 2.000)
c
c ACORN parameters:
c
      parameter (kordei = 12, maxop1 = kordei + 1, maxint = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      real prop(11)
      integer var(150,150,1), ntrain(11,11,4,24), nact(11,11,4,24), ntry
     1   (10,11,11,4,24), num(4,24), seed, report, ixl(4), iyl(4), izl(4
     2   ), nlag(4), icross(4), icat(11)
      character datafl*40, trainfl*40, outfl*40, dbgfl*40
 
      common /iaco/ixv(maxop1)
 
      common /genral/nsim, nx, ny, nz, nr, np, nv, lout, idbg, report, 
     1   ldbg, seed, maxit, tol, var, num, ndir, nlag, mlag, ixl, iyl, 
     2   izl, icross, ntry, ntrain, nact, prop, ncat, icat
 
      common /charac/datafl, trainfl, outfl, dbgfl
      double precision acorni
c
c Initialize the starting two point histogram, and objective funtion:
c
      current = object(0)
      objrsc = 1.0/max(current,0.000001)
      current = objrsc*current
c
c The random path generation procedure of Srivastava:
c
      nxy = nx*ny
      nxyz = nx*ny*nz
      modlus = 1
      modlus = modlus*2
 1003 continue
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      if (modlus .gt. nxyz) go to 1002
      modlus = modlus*2
      go to 1003
 1002 continue
c
c MAIN LOOP TO MAXIMUM NUMBER OF ITERATIONS:
c
      do iloop = 1, maxit
         write (*, 100) iloop, current
  100    format(' Working on ',i2,' objective function: ',f12.9)
         if (current .ge. tol) then
c
c MAIN LOOP OVER ALL THE NODES (unless we're done?):
c
            index = int(real(acorni(idum))*nxyz + 1)
            do in = 1, nxyz
c
c Figure out the location of this node:
c
               iz = int((index - 1)/nxy) + 1
               iy = int((index - (iz - 1)*nxy - 1)/nx) + 1
               ix = index - (iz - 1)*nxy - (iy - 1)*nx
c
c Compute the two point histogram and objective function for rock types:
c
               call update (ix, iy, iz)
               best = current
               ibest = var(ix,iy,iz)
               do ir = 1, nr
                  if (ir .ne. var(ix,iy,iz)) then
                     objtry = objrsc*object(ir)
                     if (objtry .lt. best) then
                        best = objtry
                        ibest = ir
                     endif
                  endif
               end do
c
c Decide on the best and keep it:
c
               if (ibest .ne. var(ix,iy,iz)) then
                  var(ix,iy,iz) = ibest
                  current = best
                  do ir = 1, 11
                     do jr = 1, 11
                        do id = 1, ndir
                           do il = 1, nlag(id)
                              nact(ir,jr,id,il)=ntry(ibest,ir,jr,id,il)
                           end do
                        end do
                     end do
                  end do
               endif
c
c Get a new node to consider:
c
               index = mod(5*index + 1,modlus)
 1005          continue
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               if (index.le.nxyz .and. index.ge.1) go to 1004
               index = mod(5*index + 1,modlus)
               go to 1005
 1004          continue
c
c END MAIN LOOP OVER NODES:
c
            end do
c
c Write this realization to the output file?
c
         endif
         if (int(iloop/report)*report.eq.iloop .or. iloop.eq.maxit .or. 
     1      current.lt.tol) then
            do iz = 1, nz
               do iy = 1, ny
                  do ix = 1, nx
                     ind = var(ix,iy,iz)
                     write (lout, '(i1)') icat(ind)
                  end do
               end do
            end do
            if (current .lt. tol) return 
         endif
c
c END MAIN LOOP OVER MAXIMUM ITERATIONS:
c
      end do
      return 
      end 
 
 
      subroutine update(ix, iy, iz)
c-----------------------------------------------------------------------
c
c       Considering a node - decide on the best value to keep
c
c
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      parameter (maxx = 150, maxy = 150, maxz = 1, maxlag = 24, maxdir
     1    = 4, maxrc = 10, maxroc = maxrc + 1, version = 2.000)
c
c ACORN parameters:
c
      parameter (kordei = 12, maxop1 = kordei + 1, maxint = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      real prop(11)
      integer var(150,150,1), ntrain(11,11,4,24), nact(11,11,4,24), ntry
     1   (10,11,11,4,24), num(4,24), seed, report, ixl(4), iyl(4), izl(4
     2   ), nlag(4), icross(4), icat(11)
      character datafl*40, trainfl*40, outfl*40, dbgfl*40
 
      common /iaco/ixv(maxop1)
 
      common /genral/nsim, nx, ny, nz, nr, np, nv, lout, idbg, report, 
     1   ldbg, seed, maxit, tol, var, num, ndir, nlag, mlag, ixl, iyl, 
     2   izl, icross, ntry, ntrain, nact, prop, ncat, icat
 
      common /charac/datafl, trainfl, outfl, dbgfl
      inow = var(ix,iy,iz)
c
c Initialize:
c
      do irtry = 1, nr
         do ir = 1, 11
            do jr = 1, 11
               do id = 1, ndir
                  do il = 1, nlag(id)
                     ntry(irtry,ir,jr,id,il) = nact(ir,jr,id,il)
                  end do
               end do
            end do
         end do
      end do
c
c MAIN LOOP OVER ALL ROCK TYPES:
c
      do ir = 1, nr
         if (ir .ne. inow) then
c
c Consider the change to all lags and directions:
c
            do id = 1, ndir
               do il = 1, nlag(id)
 
c
c      Update the positive lag:
c
                  jx = ix + il*ixl(id)
                  jy = iy + il*iyl(id)
                  jz = iz + il*izl(id)
                  if (.not.(jx.gt.nx .or. jy.gt.ny .or. jz.gt.nz)) then
                     if (.not.(jx.lt.1 .or. jy.lt.1 .or. jz.lt.1)) then
                        j = var(jx,jy,jz)
                        ntry(ir,inow,j,id,il)=ntry(ir,inow,j,id,il)-1
                        ntry(ir,ir,j,id,il) = ntry(ir,ir,j,id,il) + 1
c
c      Update the negative lag:
c
                     endif
                  endif
                  jx = ix - il*ixl(id)
                  jy = iy - il*iyl(id)
                  jz = iz - il*izl(id)
                  if (.not.(jx.gt.nx .or. jy.gt.ny .or. jz.gt.nz)) then
                     if (.not.(jx.lt.1 .or. jy.lt.1 .or. jz.lt.1)) then
                        j = var(jx,jy,jz)
                        ntry(ir,j,inow,id,il)=ntry(ir,j,inow,id,il)-1
                        ntry(ir,j,ir,id,il) = ntry(ir,j,ir,id,il) + 1
 
                     endif
                  endif
               end do
            end do
c
c END loop over rock types:
c
         endif
      end do
      return 
      end 
 
 
 
      subroutine tphist(iflag)
c-----------------------------------------------------------------------
c
c Compute a two point histogram of an array "var" that is nx by ny by nz
c (dimensioned for MAXX by MAXY by MAXZ), for "nr" rock types, "nlag"
c lags, "ndir" directions specified by integer arrays "ixl", "iyl",
c "izl".  Put the result in the "tp" array that is dimensioned MP by MV
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      parameter (maxx = 150, maxy = 150, maxz = 1, maxlag = 24, maxdir
     1    = 4, maxrc = 10, maxroc = maxrc + 1, version = 2.000)
c
c ACORN parameters:
c
      parameter (kordei = 12, maxop1 = kordei + 1, maxint = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      real prop(11)
      integer var(150,150,1), ntrain(11,11,4,24), nact(11,11,4,24), ntry
     1   (10,11,11,4,24), num(4,24), seed, report, ixl(4), iyl(4), izl(4
     2   ), nlag(4), icross(4), icat(11)
      character datafl*40, trainfl*40, outfl*40, dbgfl*40
 
      common /iaco/ixv(maxop1)
 
      common /genral/nsim, nx, ny, nz, nr, np, nv, lout, idbg, report, 
     1   ldbg, seed, maxit, tol, var, num, ndir, nlag, mlag, ixl, iyl, 
     2   izl, icross, ntry, ntrain, nact, prop, ncat, icat
 
      common /charac/datafl, trainfl, outfl, dbgfl
      do ir = 1, 11
         do jr = 1, 11
            do id = 1, ndir
               do il = 1, nlag(id)
                  if (iflag .eq. 0) then
                     ntrain(ir,jr,id,il) = 0
                  else
                     nact(ir,jr,id,il) = 0
                  endif
                  num(id,il) = 0
               end do
            end do
         end do
      end do
c
c Calculate the Experimental two point histogram:
c
      do iz = 1, nz
         do iy = 1, ny
            do ix = 1, nx
c
c Consider the first value and all directions and lags:
c
               i = var(ix,iy,iz)
               do id = 1, ndir
                  do il = 1, nlag(id)
                     ii = ix + il*ixl(id)
                     jj = iy + il*iyl(id)
                     kk = iz + il*izl(id)
                     if(.not.(ii.gt.nx.or.jj.gt.ny.or.kk.gt.nz))then
                        if(.not.(ii.lt.1.or.jj.lt.1.or.kk.lt.1))then
c
c If the second point is within the grid then keep the sample:
c
                           j = var(ii,jj,kk)
                           if (iflag .eq. 0) then
                              ntrain(i,j,id,il) = ntrain(i,j,id,il) + 1
                           else
                              nact(i,j,id,il) = nact(i,j,id,il) + 1
                           endif
                           num(id,il) = num(id,il) + 1
                        endif
                     endif
                  end do
               end do
            end do
         end do
      end do
c
c Debugging output:
c
      if (idbg .ge. 3) then
         do ir = 1, nr
            do jr = 1, nr
               do id = 1, ndir
                  do il = 1, nlag(id)
                     write (ldbg, 100) ir, jr, id, il, ntrain(ir,jr,id,
     1                  il), nact(ir,jr,id,il)
                  end do
               end do
            end do
         end do
  100    format('ir jr ',2i5,' id il ',2i5,' train act ',2i12)
      endif
c
c Return with the two point histogram:
c
      return 
      end 
 
 
 
      REAL FUNCTION OBJECT (IFLAG)
c-----------------------------------------------------------------------
c
c Compute the objective function given a training two point histogram
c and an experimental two point histogram.
c
c
c-----------------------------------------------------------------------
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C                                                                      %
C Copyright (C) 1996, The Board of Trustees of the Leland Stanford     %
C Junior University.  All rights reserved.                             %
C                                                                      %
C The programs in GSLIB are distributed in the hope that they will be  %
C useful, but WITHOUT ANY WARRANTY.  No author or distributor accepts  %
C responsibility to anyone for the consequences of using them or for   %
C whether they serve any particular purpose or work at all, unless he  %
C says so in writing.  Everyone is granted permission to copy, modify  %
C and redistribute the programs in GSLIB, but only under the condition %
C that this notice and the above copyright notice remain intact.       %
C                                                                      %
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-----------------------------------------------------------------------
c
c The following Parameters control static dimensioning within anneal:
c
c   MAXX      maximum nodes in X
c   MAXY      maximum nodes in Y
c   MAXZ      maximum nodes in Z
c   MAXLAG    maximum number of lags in variogram calculation
c   MAXDIR    maximum number of directions for variogram calculation
c   MAXRC     maximum number of rock codes
c
c
c-----------------------------------------------------------------------
c
c General parameters:
c
      PARAMETER (MAXX = 150, MAXY = 150, MAXZ = 1, MAXLAG = 24, MAXDIR
     1    = 4, MAXRC = 10, MAXROC = MAXRC + 1, VERSION = 2.000)
c
c ACORN parameters:
c
      PARAMETER (KORDEI = 12, MAXOP1 = KORDEI + 1, MAXINT = 2**30)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c
c Dimensioning:
c
      REAL PROP(11)
      INTEGER VAR(150,150,1), NTRAIN(11,11,4,24), NACT(11,11,4,24), NTRY
     1   (10,11,11,4,24), NUM(4,24), SEED, REPORT, IXL(4), IYL(4), IZL(4
     2   ), NLAG(4), ICROSS(4), ICAT(11)
      CHARACTER DATAFL*40, TRAINFL*40, OUTFL*40, DBGFL*40
 
      COMMON /IACO/IXV(MAXOP1)
 
      COMMON /GENRAL/NSIM, NX, NY, NZ, NR, NP, NV, LOUT, IDBG, REPORT, 
     1   LDBG, SEED, MAXIT, TOL, VAR, NUM, NDIR, NLAG, MLAG, IXL, IYL, 
     2   IZL, ICROSS, NTRY, NTRAIN, NACT, PROP, NCAT, ICAT
 
      COMMON /CHARAC/DATAFL, TRAINFL, OUTFL, DBGFL
      OBJECT = 0.0
c
c Loop over all direction vectors and rock codes:
c
      DO ID = 1, NDIR
         DO IL = 1, NLAG(ID)
            IF (NUM(ID,IL) .GT. 0) THEN
               DO IR = 1, NR
                  DO JR = 1, NR
                     IF (ICROSS(ID).NE.0 .OR. IR.EQ.JR) THEN
                        IF (IFLAG .EQ. 0) THEN
                           ACTUAL = NACT(IR,JR,ID,IL)
                        ELSE
                           ACTUAL = NTRY(IFLAG,IR,JR,ID,IL)
                        ENDIF
                        OBJECT = OBJECT + (ACTUAL - NTRAIN(IR,JR,ID,IL))
     1                     *(ACTUAL - NTRAIN(IR,JR,ID,IL))/(NUM(ID,IL)*
     2                     NUM(ID,IL))
                     ENDIF
                  END DO
               END DO
            ENDIF
         END DO
      END DO
c
c Return with the objective function:
c
      RETURN 
      END 
 
 
 
      subroutine makepar
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:07 3/14/00
C...Switches:                     
c-----------------------------------------------------------------------
c
c                      Write a Parameter File
c                      **********************
c
c
c
c-----------------------------------------------------------------------
      lun = 99
      open(lun, file='anneal.par', status='UNKNOWN')
      write (lun, 10)
   10 format('                  Parameters for ANNEAL',/,
     1   '                  *********************',/,/,
     2   'START OF PARAMETERS:')
 
      write (lun, 11)
   11 format('sisim.out                         ',
     1   '-file with input image(s)')
      write (lun, 12)
   12 format('ellipsim.out                      ',
     1   '-file with training image')
      write (lun, 13)
   13 format('3   10                            ',
     1   '-debug level, reporting interval')
      write (lun, 14)
   14 format('postsim.dbg                       ',
     1   '-file for debug output')
      write (lun, 15)
   15 format('postsim.out                       ',
     1   '-file for output simulation')
      write (lun, 16)
   16 format('1                                 ',
     1   '-number of realizations')
      write (lun, 17)
   17 format(' 25   25  1                       ','-nx, ny, nz')
      write (lun, 18)
   18 format('69069                             ','-random number seed')
      write (lun, 19)
   19 format('5   0.000001                      ',
     1   '-maximum iterations, tolerance')
      write (lun, 20)
   20 format('4                                 ',
     1   '-number of directions')
      write (lun, 21)
   21 format('1  0  0  10                       ','-ixl, iyl, izl, nlag'
     1   )
      write (lun, 22)
   22 format('0  1  0  10                       ','-ixl, iyl, izl, nlag'
     1   )
      write (lun, 23)
   23 format('1  1  0   5                       ','-ixl, iyl, izl, nlag'
     1   )
      write (lun, 24)
   24 format('1 -1  0   5                       ','-ixl, iyl, izl, nlag'
     1   )
 
      close(lun)
      return 
      end 
