 
 
 
      subroutine vargplt(np, ar1, ar2, vpxmin, vpxmax, vpymin, vpymax, 
     1   xvmin, xvmax, yvmin, yvmax, title, reset)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:09 3/14/00
C...Switches:                     
c-----------------------------------------------------------------------
c
c                          Variogram Plotting
c                          ******************
c
c
c PARAMETERS:
c      np      The number of pairs to plot
c      ar1     The distance (x axis)
c      ar2     The variogram value
c      vpxmin  minimum X to use for variogram plotting
c      vpxmax  maximum X to use for variogram plotting
c      vpymin  minimum Y to use for variogram plotting
c      vpymax  maximum Y to use for variogram plotting
c
c
c
c-----------------------------------------------------------------------
      real ar1(*), ar2(*), xx(250), yy(250)
      character title*80
      logical reset
      integer idash
      save idash
      real xvmn
      save xvmn
      real xvmx
      save xvmx
      real yvmn
      save yvmn
      real yvmx
      save yvmx
c
c Common variables for Postscript Plotting:
c
      common /psdata/lpsout, pscl, pxmin, pxmax, pymin, pymax, wxmin, 
     1   wxmax, wymin, wymax
c     common /olddat/ xvmn,xvmx,yvmn,yvmx
c
c Label the axes and write the title if reset is true:
c
      xrange = vpxmax - vpxmin
      yrange = vpymax - vpymin
      if (reset) then
         ts = 7.5
         xvmn = xvmin
         xvmx = xvmax
         yvmn = yvmin
         yvmx = yvmax
         write (lpsout, 100)
  100    format('gsave /Symbol findfont 100 scalefont setfont ',
     1      '0 501 m (g) rtext grestore')
         xloc = vpxmin + 0.50*xrange
         yloc = vpymin - 0.15*yrange
         call pstext (xloc, yloc, 8, 'Distance', ts, 1, 0.0, 1)
         xloc = vpxmin
         yloc = vpymax + 0.01*(vpxmax - vpxmin)
         call pstext (xloc, yloc, 80, title, 9.0, 3, 0.0, 0)
         idash = -1
         ilog = 0
         i45 = 0
c
c Scale and Draw the axes:
c
         call scal (xvmin, xvmax, yvmin, yvmax, vpxmin, vpxmax, vpymin, 
     1      vpymax, ilog, i45)
      endif
c
c Now mark all the points:
c
      if (title(1:2) .ne. 'Mo') then
         do i = 1, np
            xloc = resc(xvmn,xvmx,vpxmin,vpxmax,ar1(i))
            yloc = resc(yvmn,yvmx,vpymin,vpymax,ar2(i))
            ix = int(resc(wxmin,wxmax,pxmin,pxmax,xloc)/pscl)
            iy = int(resc(wymin,wymax,pymin,pymax,yloc)/pscl)
            ix = max0(0,ix)
            iy = max0(0,iy)
            ix = min0(2000,ix)
            iy = min0(2000,iy)
            write (lpsout, 32) ix, iy
         end do
      endif
   32 format('n ',i4.4,1x,i4.4,' bullet')
c
c Draw a light dashed line connecting the experimental variogram points:
c
      idash = idash + 1
      do i = 1, np
         xx(i) = resc(xvmn,xvmx,vpxmin,vpxmax,ar1(i))
         yy(i) = resc(yvmn,yvmx,vpymin,vpymax,ar2(i))
      end do
      call psline (np, xx, yy, 0.3, idash)
c
c Return to calling program:
c
      return 
      end 
 
 
 
      subroutine rmtrail(str, lostr, lost)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:09 3/14/00
C...Switches:                     
c-----------------------------------------------------------------------
c
c Find out how much of character string is non-blank - return length
c
c-----------------------------------------------------------------------
      character str*80
      lost = lostr
      do i = 1, lostr
         ix = lostr - i + 1
         if (str(ix:ix) .ne. ' ') return 
         lost = lost - 1
      end do
      return 
      end 
 
 
 
      subroutine boxplt(vpxmin, vpxmax, vpymin, vpymax, xvmin, xvmax, 
     1   yvmin, yvmax, zmin, zlq, zmed, zmen, zuq, zmax, dist)
C...Translated by Pacific-Sierra Research vf90 Personal 3.4N5 10:25:09 3/14/00
C...Switches:                     
c-----------------------------------------------------------------------
c
c                          Box Plot of Variograms
c                          **********************
c
c PARAMTERS:
c      vpxmin,vpxmax    X limits for variogram on plot
c      vpymin,vpymax    Y limits for variogram on plot
c      xvmin,xvmax      Distance limits established from file
c      yvmin,yvmax      Variogram limits established from file
c      zmin,zlu,zmed,zmen,zuq,zmax      Box plot parameters from file
c      dist             Distance for box plot.
c
c
c
c-----------------------------------------------------------------------
      real xx(6), yy(6)
c
c Common variables for Postscript Plotting:
c
      common /psdata/lpsout, pscl, pxmin, pxmax, pymin, pymax, wxmin, 
     1   wxmax, wymin, wymax
      write (lpsout, 100)
  100 format('%',/,'% BOX PLOT:',/,'%')
c
c Draw a light line connecting the minimum and maximum:
c
      np = 6
      disl = dist - 0.010*(xvmax - xvmin)
      dish = dist + 0.010*(xvmax - xvmin)
      xx(1) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      xx(2) = resc(xvmin,xvmax,vpxmin,vpxmax,dish)
      xx(3) = resc(xvmin,xvmax,vpxmin,vpxmax,dist)
      xx(4) = resc(xvmin,xvmax,vpxmin,vpxmax,dist)
      xx(5) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      xx(6) = resc(xvmin,xvmax,vpxmin,vpxmax,dish)
      yy(1) = resc(yvmin,yvmax,vpymin,vpymax,zmax)
      yy(2) = resc(yvmin,yvmax,vpymin,vpymax,zmax)
      yy(3) = resc(yvmin,yvmax,vpymin,vpymax,zmax)
      yy(4) = resc(yvmin,yvmax,vpymin,vpymax,zmin)
      yy(5) = resc(yvmin,yvmax,vpymin,vpymax,zmin)
      yy(6) = resc(yvmin,yvmax,vpymin,vpymax,zmin)
      call psline (np, xx, yy, 0.3, 0)
c
c Draw the box at the quartiles:
c
      np = 5
      xx(1) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      xx(2) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      xx(3) = resc(xvmin,xvmax,vpxmin,vpxmax,dish)
      xx(4) = resc(xvmin,xvmax,vpxmin,vpxmax,dish)
      xx(5) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      yy(1) = resc(yvmin,yvmax,vpymin,vpymax,zlq)
      yy(2) = resc(yvmin,yvmax,vpymin,vpymax,zuq)
      yy(3) = resc(yvmin,yvmax,vpymin,vpymax,zuq)
      yy(4) = resc(yvmin,yvmax,vpymin,vpymax,zlq)
      yy(5) = resc(yvmin,yvmax,vpymin,vpymax,zlq)
      call psfill (np, xx, yy, 0.3, 0.93)
c
c Draw the line at the median:
c
      np = 2
      xx(1) = resc(xvmin,xvmax,vpxmin,vpxmax,disl)
      xx(2) = resc(xvmin,xvmax,vpxmin,vpxmax,dish)
      yy(1) = resc(yvmin,yvmax,vpymin,vpymax,zmed)
      yy(2) = resc(yvmin,yvmax,vpymin,vpymax,zmed)
      call psline (np, xx, yy, 1.0, 0)
c
c Now mark the mean:
c
      xloc = resc(xvmin,xvmax,vpxmin,vpxmax,dist)
      yloc = resc(yvmin,yvmax,vpymin,vpymax,zmen)
      ix = int(resc(wxmin,wxmax,pxmin,pxmax,xloc)/pscl)
      iy = int(resc(wymin,wymax,pymin,pymax,yloc)/pscl)
      write (lpsout, 32) ix, iy
   32 format('n ',i4.4,1x,i4.4,' bullet')
c
c Return to calling program:
c
      return 
      end 
